package nc.ui.gl.multibooksdef;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.HashSet;
import java.util.Vector;
import javax.swing.JPanel;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Log;
import nc.bs.uif2.common.DlgComponentUtil;
import nc.itf.uap.rbac.function.IFuncPower;
import nc.ui.bd.GLOrgBookAccBO_Client;
import nc.ui.gl.accbook.GLListList;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.vo.bd.b54.GlorgbookVO;

public class GlOrgBookListToListDialog extends UIDialog {

   private UIButton ivjBnCancel = null;
   private UIButton ivjBnOK = null;
   private JPanel ivjUIDialogContentPane = null;
   private UIPanel ivjUIPanel1 = null;
   GlOrgBookListToListDialog.IvjEventHandler ivjEventHandler = new GlOrgBookListToListDialog.IvjEventHandler();
   private UIButton ivjBnRefresh = null;
   private String func_code = null;
   private GLListList ivjGLListList1 = null;


   public GlOrgBookListToListDialog() {
      this.initialize();
   }

   public GlOrgBookListToListDialog(Container parent) {
      super(parent);
      this.initialize();
   }

   public GlOrgBookListToListDialog(Container parent, String title) {
      super(parent, title);
      this.initialize();
   }

   public GlOrgBookListToListDialog(Frame owner) {
      super(owner);
      this.initialize();
   }

   public GlOrgBookListToListDialog(Frame owner, String title) {
      super(owner, title);
      this.initialize();
   }

   public void bnCancel_ActionPerformed(ActionEvent actionEvent) {
      this.closeCancel();
   }

   public void bnOK_ActionPerformed(ActionEvent actionEvent) {
      this.closeOK();
   }

   public void bnRefresh_ActionPerformed(ActionEvent actionEvent) {
      try {
         this.refreshBesidesTheGlorgbook(((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getPrimaryKey(), this.func_code);
      } catch (Exception var3) {
         Log.getInstance(this.getClass()).error(var3);
         MessageDialog.showErrorDlg(this, NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000164"), var3.getMessage());
      }

   }

   private void connEtoC1(ActionEvent arg1) {
      try {
         this.bnOK_ActionPerformed(arg1);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

   }

   private void connEtoC2(ActionEvent arg1) {
      try {
         this.bnCancel_ActionPerformed(arg1);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

   }

   private void connEtoC3(ActionEvent arg1) {
      try {
         this.bnRefresh_ActionPerformed(arg1);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

   }

   private UIButton getBnCancel() {
      if(this.ivjBnCancel == null) {
         try {
            this.ivjBnCancel = new UIButton();
            this.ivjBnCancel.setName("BnCancel");
            this.ivjBnCancel.setText(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000317"));
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjBnCancel;
   }

   private UIButton getBnOK() {
      if(this.ivjBnOK == null) {
         try {
            this.ivjBnOK = new UIButton();
            this.ivjBnOK.setName("BnOK");
            this.ivjBnOK.setText(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000318"));
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjBnOK;
   }

   private UIButton getBnRefresh() {
      if(this.ivjBnRefresh == null) {
         try {
            this.ivjBnRefresh = new UIButton();
            this.ivjBnRefresh.setName("BnRefresh");
            this.ivjBnRefresh.setText(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000180"));
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjBnRefresh;
   }

   public GLListList getGLListList1() {
      if(this.ivjGLListList1 == null) {
         try {
            this.ivjGLListList1 = new GLListList();
            this.ivjGLListList1.setName("GLListList1");
            this.setSize(this.ivjGLListList1.getDlgSize());
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjGLListList1;
   }

   public String[] getSelectedGlorgbooks() {
      Object[] selectedobj = this.getGLListList1().getRightKeys();
      if(selectedobj != null && selectedobj.length > 0) {
         String[] pks = new String[selectedobj.length];

         for(int i = 0; i < selectedobj.length; ++i) {
            pks[i] = ((GlorgbookVO)selectedobj[i]).getPrimaryKey();
         }

         return pks;
      } else {
         return null;
      }
   }

   private JPanel getUIDialogContentPane() {
      if(this.ivjUIDialogContentPane == null) {
         try {
            this.ivjUIDialogContentPane = new JPanel();
            this.ivjUIDialogContentPane.setName("UIDialogContentPane");
            this.ivjUIDialogContentPane.setLayout(new BorderLayout());
            this.getUIDialogContentPane().add(this.getGLListList1(), "Center");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjUIDialogContentPane;
   }

   private UIPanel getUIPanel1() {
      if(this.ivjUIPanel1 == null) {
         try {
            this.ivjUIPanel1 = new UIPanel();
            this.ivjUIPanel1.setName("UIPanel1");
            this.ivjUIPanel1.setPreferredSize(new Dimension(10, 30));
            this.getUIPanel1().add(this.getBnRefresh(), this.getBnRefresh().getName());
            this.getUIPanel1().add(this.getBnOK(), this.getBnOK().getName());
            this.getUIPanel1().add(this.getBnCancel(), this.getBnCancel().getName());
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjUIPanel1;
   }

   private void handleException(Throwable exception) {
   }

   private void initConnections() throws Exception {
      this.getBnOK().addActionListener(this.ivjEventHandler);
      this.getBnCancel().addActionListener(this.ivjEventHandler);
      this.getBnRefresh().addActionListener(this.ivjEventHandler);
   }

   private void initialize() {
      try {
         this.setName("GlOrgBookListToListDialog");
         this.setDefaultCloseOperation(2);
         this.setContentPane(DlgComponentUtil.getMainDlgPanel(this.getUIDialogContentPane(), new UIButton[]{this.getBnRefresh(), this.getBnOK(), this.getBnCancel()}));
         this.initConnections();
      } catch (Throwable var2) {
         this.handleException(var2);
      }

   }

   public static void main(String[] args) {
      try {
         GlOrgBookListToListDialog exception = new GlOrgBookListToListDialog();
         exception.setModal(true);
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var3) {
         System.err.println("nc.ui.pub.beans.UIDialog 的 main() 中发生异常");
         var3.printStackTrace(System.out);
      }

   }

   public void refresh() throws Exception {
      GlorgbookVO[] glorgbookVOs = GLOrgBookAccBO_Client.getGlOrgBookVOsByPk_GlBook(((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getPk_glbook());
      if(glorgbookVOs != null && glorgbookVOs.length > 0) {
         String[] strGlorgbooks = new String[glorgbookVOs.length];

         for(int i = 0; i < glorgbookVOs.length; ++i) {
            strGlorgbooks[i] = glorgbookVOs[i].getGlorgbookname();
         }

         this.getGLListList1().setLeftData(strGlorgbooks, glorgbookVOs);
      }

   }

   public void refreshBesidesTheGlorgbook(String pk_glorgbook, String func_code) throws Exception {
      this.func_code = func_code;
      String[] pks = ((IFuncPower)NCLocator.getInstance().lookup(IFuncPower.class.getName())).queryPowerOrgBook(ClientEnvironment.getInstance().getUser().getPrimaryKey(), func_code, (String)null);
      HashSet powerpks = new HashSet();

      for(int glorgbookVOs = 0; pks != null && glorgbookVOs < pks.length; ++glorgbookVOs) {
         powerpks.add(pks[glorgbookVOs]);
      }

      GlorgbookVO[] var10 = GLOrgBookAccBO_Client.getGlOrgBookVOsByPk_GlBook(((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getPk_glbook());
      if(var10 != null && var10.length > 0) {
         Vector v = new Vector();

         for(int orgbooks = 0; orgbooks < var10.length; ++orgbooks) {
            if(powerpks.contains(var10[orgbooks].getPrimaryKey()) && !var10[orgbooks].getPrimaryKey().equals(pk_glorgbook)) {
               v.addElement(var10[orgbooks]);
            }
         }

         GlorgbookVO[] var11 = null;
         if(v.size() > 0) {
            var11 = new GlorgbookVO[v.size()];
            v.copyInto(var11);
         }

         if(var11 != null && var11.length > 0) {
            String[] strGlorgbook = new String[var11.length];

            for(int i = 0; i < var11.length; ++i) {
               strGlorgbook[i] = var11[i].getGlorgbookname();
            }

            this.getGLListList1().setLeftData(strGlorgbook, var11);
            this.getGLListList1().setRightData((Object[])null);
         }
      }

   }

   public String getFunc_code() {
      return this.func_code;
   }

   public void setFunc_code(String func_code) {
      this.func_code = func_code;
   }

   class IvjEventHandler implements ActionListener {

      public void actionPerformed(ActionEvent e) {
         if(e.getSource() == GlOrgBookListToListDialog.this.getBnOK()) {
            GlOrgBookListToListDialog.this.connEtoC1(e);
         }

         if(e.getSource() == GlOrgBookListToListDialog.this.getBnCancel()) {
            GlOrgBookListToListDialog.this.connEtoC2(e);
         }

         if(e.getSource() == GlOrgBookListToListDialog.this.getBnRefresh()) {
            GlOrgBookListToListDialog.this.connEtoC3(e);
         }

      }
   }
}
